//+----------------------------------------------------------------------------+
//|                                                        e-SampleOrders.mq4  |
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |
//|                                                                            |
//|  31.10.2006       .                     |
//+----------------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

//-------    ------------------------------------------

//-------    --------------------------------------
double Lots         = 0.1;                  // 
int    Slippage     = 3;                    // 
color  clOpenBuy    = LightBlue;            //   
color  clOpenSell   = LightCoral;           //   
color  clModifyBuy  = Aqua;                 //   
color  clModifySell = Tomato;               //   
color  clCloseBuy   = Blue;                 //   
color  clCloseSell  = Red;                  //   

//-------    ------------------------------------------


//+----------------------------------------------------------------------------+
//|  expert start function                                                     |
//+----------------------------------------------------------------------------+
void start() {
  ManageOrders();
}

//+----------------------------------------------------------------------------+
//|                                               |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                  (-1 -  )                     |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
void ClosePositions(string sym="", int op=-1, int mn=-1) {
  int i, k=OrdersTotal();

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sym && (op<0 || OrderType()==op)) {
        if (mn<0 || OrderMagicNumber()==mn) {
          if (OrderType()==OP_BUY) {
            OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, clCloseBuy);
          }
          if (OrderType()==OP_SELL) {
            OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, clCloseSell);
          }
        }
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|                                                             |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                  (-1 -  )                       |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
void DeleteOrders(string sym="", int op=-1, int mn=-1) {
  int i, k=OrdersTotal(), ot;

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      ot=OrderType();
      if (ot==OP_BUYLIMIT || ot==OP_SELLLIMIT || ot==OP_BUYSTOP || ot==OP_SELLSTOP) {
        if (OrderSymbol()==sym && (op<0 || OrderType()==op)) {
          if (mn<0 || OrderMagicNumber()==mn) OrderDelete(OrderTicket());
        }
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|                                          |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                  (-1 -  )                     |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
bool ExistPositions(string sym="", int op=-1, int mn=-1) {
  int i, k=OrdersTotal();

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sym) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) return(True);
          }
        }
      }
    }
  }
  return(False);
}

//+----------------------------------------------------------------------------+
//|                                           |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                  (-1 -  )                       |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
bool ExistOrders(string sym="", int op=-1, int mn=-1) {
  int i, k=OrdersTotal(), ot;

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      ot=OrderType();
      if (ot==OP_BUYLIMIT || ot==OP_SELLLIMIT || ot==OP_BUYSTOP || ot==OP_SELLSTOP) {
        if (OrderSymbol()==sym && (op<0 || OrderType()==op)) {
          if (mn<0 || OrderMagicNumber()==mn) return(True);
        }
      }
    }
  }
  return(False);
}
//+----------------------------------------------------------------------------+
//|    .                                              |
//|  :                                                                |
//|    ms  -                                                     |
//|    sym -   ("" -  )                    |
//|    tf  -                 ( 0 -  )                 |
//+----------------------------------------------------------------------------+
void GetTradeSignals(double& ms[][], string sym="", int tf=0) {
  if (sym=="") sym=Symbol();

  //      ms:
  // ms[ 0][0]!=0;      // Buy
  // ms[ 1][0]!=0;      // Sell
  // ms[ 2][0]!=0;      // Set BuyLimit
  // ms[ 3][0]!=0;      // Set SellLimit
  // ms[ 4][0]!=0;      // Set BuyStop
  // ms[ 5][0]!=0;      // Set SellStop
  // ms[ 6][0]!=0;      // Close Buy
  // ms[ 7][0]!=0;      // Close Sell
  // ms[ 8][0]!=0;      // Delete BuyLimit
  // ms[ 9][0]!=0;      // Delete SellLimit
  // ms[10][0]!=0;      // Delete BuyStop
  // ms[11][0]!=0;      // Delete SellStop
  // ms[12][0]!=0;      // Modify BuyLimit
  // ms[13][0]!=0;      // Modify SellLimit
  // ms[14][0]!=0;      // Modify BuyStop
  // ms[15][0]!=0;      // Modify SellStop

  // ms[ 0][1]!=0;      // SL for Buy
  // ms[ 1][1]!=0;      // SL for Sell
  // ms[ 2][1]!=0;      // SL for Set BuyLimit
  // ms[ 3][1]!=0;      // SL for Set SellLimit
  // ms[ 4][1]!=0;      // SL for Set BuyStop
  // ms[ 5][1]!=0;      // SL for Set SellStop
  // ms[12][1]!=0;      // SL for Modify BuyLimit
  // ms[13][1]!=0;      // SL for Modify SellLimit
  // ms[14][1]!=0;      // SL for Modify BuyStop
  // ms[15][1]!=0;      // SL for Modify SellStop

  // ms[ 0][2]!=0;      // TP for Buy
  // ms[ 1][2]!=0;      // TP for Sell
  // ms[ 2][2]!=0;      // TP for Set BuyLimit
  // ms[ 3][2]!=0;      // TP for Set SellLimit
  // ms[ 4][2]!=0;      // TP for Set BuyStop
  // ms[ 5][2]!=0;      // TP for Set SellStop
  // ms[12][2]!=0;      // TP for Modify BuyLimit
  // ms[13][2]!=0;      // TP for Modify SellLimit
  // ms[14][2]!=0;      // TP for Modify BuyStop
  // ms[15][2]!=0;      // TP for Modify SellStop
}

//+----------------------------------------------------------------------------+
//|                                                          |
//+----------------------------------------------------------------------------+
void ManageOrders() {
  double ms[16][3];

  ArrayInitialize(ms, 0.0);
  GetTradeSignals(ms);

  //  
  if (ExistPositions()) {
    if (ms[6][0]>0) ClosePositions("", OP_BUY);
    if (ms[7][0]>0) ClosePositions("", OP_SELL);
  }

  //  
  if (ExistOrders()) {
    if (ms[ 8][0]>0) DeleteOrders("", OP_BUYLIMIT);
    if (ms[ 9][0]>0) DeleteOrders("", OP_SELLLIMIT);
    if (ms[10][0]>0) DeleteOrders("", OP_BUYSTOP);
    if (ms[11][0]>0) DeleteOrders("", OP_SELLSTOP);
  }

  //  
  if (ExistOrders()) {
    if (ms[12][0]>0) ModifyOrder("", OP_BUYLIMIT , ms[12][0], ms[12][1], ms[12][2]);
    if (ms[13][0]>0) ModifyOrder("", OP_SELLLIMIT, ms[13][0], ms[13][1], ms[13][2]);
    if (ms[14][0]>0) ModifyOrder("", OP_BUYSTOP  , ms[14][0], ms[14][1], ms[14][2]);
    if (ms[15][0]>0) ModifyOrder("", OP_SELLSTOP , ms[15][0], ms[15][1], ms[15][2]);
  }

  //  
  if (NumberOfBarLastOP("", 0, OP_BUY)>0) {
    if (ms[0][0]>0) OpenPosition("", OP_BUY , ms[0][1], ms[0][2]);
  }
  if (NumberOfBarLastOP("", 0, OP_SELL)>0) {
    if (ms[1][0]>0) OpenPosition("", OP_SELL, ms[1][1], ms[1][2]);
  }

  //  
  if (NumberOfBarLastOP("", 0, OP_BUYLIMIT)>0) {
    if (ms[2][0]>0) SetOrder("", OP_BUYLIMIT , ms[2][0], ms[2][1], ms[2][2]);
  }
  if (NumberOfBarLastOP("", 0, OP_SELLLIMIT)>0) {
    if (ms[3][0]>0) SetOrder("", OP_SELLLIMIT, ms[3][0], ms[3][1], ms[3][2]);
  }
  if (NumberOfBarLastOP("", 0, OP_BUYSTOP)>0) {
    if (ms[4][0]>0) SetOrder("", OP_BUYSTOP  , ms[4][0], ms[4][1], ms[4][2]);
  }
  if (NumberOfBarLastOP("", 0, OP_SELLSTOP)>0) {
    if (ms[5][0]>0) SetOrder("", OP_SELLSTOP , ms[5][0], ms[5][1], ms[5][2]);
  }
}

//+----------------------------------------------------------------------------+
//|                                                             |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                                                           |
//|    pp  -                                                               |
//|    sl  -                                                               |
//|    tp  -                                                               |
//+----------------------------------------------------------------------------+
void ModifyOrder(string sym, int op, double pp, double sl=0, double tp=0) {
  color clOpen;
  int   i, k=OrdersTotal(), ot;

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      ot=OrderType();
      if (ot==OP_BUYLIMIT || ot==OP_SELLLIMIT || ot==OP_BUYSTOP || ot==OP_SELLSTOP) {
        if (OrderSymbol()==sym && OrderType()==op) {
          if (op==OP_BUYLIMIT || op==OP_BUYSTOP) clOpen=clOpenBuy;
          else clOpen=clOpenSell;
          //     
          //    
          OrderModify(OrderTicket(), pp, sl, tp, 0, clOpen);
        }
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|          -1.      |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    tf  -                 ( 0 -  )                 |
//|    op  -                  (-1 -  )                     |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
int NumberOfBarLastOP(string sym="", int tf=0, int op=-1, int mn=-1) {
  datetime oot;
  int      i, k=OrdersTotal();

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sym && (op<0 || OrderType()==op)) {
        if (mn<0 || OrderMagicNumber()==mn) {
          if (oot<OrderOpenTime()) oot=OrderOpenTime();
        }
      }
    }
  }
  return(iBarShift(sym, tf, oot, True));
}

//+----------------------------------------------------------------------------+
//|                                                             |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                                                           |
//|    sl  -                                                               |
//|    tp  -                                                               |
//+----------------------------------------------------------------------------+
void OpenPosition(string sym, int op, double sl=0, double tp=0) {
  color  clOpen;
  double pp;

  if (sym=="") sym=Symbol();
  if (op==OP_BUY) {
    clOpen=clOpenBuy; pp=Ask;
  } else {
    clOpen=clOpenSell; pp=Bid;
  }
  OrderSend(sym, op, Lots, pp, Slippage, sl, tp, "", 0, 0, clOpen);
}

//+----------------------------------------------------------------------------+
//|                                                             |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                                                           |
//|    pp  -                                                               |
//|    sl  -                                                               |
//|    tp  -                                                               |
//+----------------------------------------------------------------------------+
void SetOrder(string sym, int op, double pp, double sl=0, double tp=0) {
  color clOpen;

  if (sym=="") sym=Symbol();
  if (op==OP_BUYLIMIT || op==OP_BUYSTOP) clOpen=clOpenBuy; else clOpen=clOpenSell;
  OrderSend(sym, op, Lots, pp, Slippage, sl, tp, "", 0, 0, clOpen);
}
//+----------------------------------------------------------------------------+

